// Do not edit this file.  It is created from etc/citation.js.
#ifndef citation_js_h
#define citation_js_h

#define AMA_CITE "If you use this program in your research, please cite:\n\nFabian A. Buske, Mikael Boden, Denis C. Bauer and Timothy L. Bailey,\n\"Assigning roles to DNA regulatory motifs using comparative genomics\",\nBioinformatics, 26(7), 860-866, 2010.\n"
#define AME_CITE "If you use this program in your research, please cite:\n\nRobert C. McLeay and Timothy L. Bailey,\n\"Motif Enrichment Analysis: a unified framework and an evaluation on ChIP data\",\nBMC Bioinformatics, 11:165, 2010.\n"
#define CentriMo_CITE "If you use this program in your research, please cite:\n\nTimothy L. Bailey and Philip Machanick,\n\"Inferring direct DNA binding from ChIP-seq\",\nNucleic Acids Research, 40:e128, 2012.\n"
#define DREME_CITE "If you use this program in your research, please cite:\n\nTimothy L. Bailey,\n\"DREME: Motif discovery in transcription factor ChIP-seq data\",\nBioinformatics, 27(12):1653-1659, 2011.\n"
#define FIMO_CITE "If you use this program in your research, please cite:\n\nCharles E. Grant, Timothy L. Bailey and William Stafford Noble,\n\"FIMO: Scanning for occurrences of a given motif\",\nBioinformatics 27(7):1017-1018, 2011.\n"
#define GLAM2_CITE "If you use this program in your research, please cite:\n\nMartin C. Frith, Neil F. W. Saunders, Bostjan Kobe and Timothy L. Bailey,\n\"Discovering sequence motifs with arbitrary insertions and deletions\",\nPLoS Computational Biology, 4(5):e1000071, 2008.\n"
#define GLAM2SCAN_CITE "If you use this program in your research, please cite:\n\nMartin C. Frith, Neil F. W. Saunders, Bostjan Kobe and Timothy L. Bailey,\n\"Discovering sequence motifs with arbitrary insertions and deletions\",\nPLoS Computational Biology, 4(5):e1000071, 2008.\n"
#define GOMo_CITE "If you use this program in your research, please cite:\n\nFabian A. Buske, Mikael Boden, Denis C. Bauer and Timothy L. Bailey,\n\"Assigning roles to DNA regulatory motifs using comparative genomics\",\nBioinformatics, 26(7), 860-866, 2010.\n"
#define MAST_CITE "If you use this program in your research, please cite:\n\nTimothy L. Bailey and Michael Gribskov,\n\"Combining evidence using p-values: application to sequence homology searches\",\nBioinformatics, 14(1):48-54, 1998.\n"
#define MCAST_CITE "If you use this program in your research, please cite:\n\nTimothy Bailey and William Stafford Noble,\n\"Searching for statistically significant regulatory modules\",\nBioinformatics (Proceedings of the European Conference on Computational Biology),\n19(Suppl. 2):ii16-ii25, 2003.\n"
#define MetaMEME_CITE "If you use this program in your research, please cite:\n\nWilliam N. Grundy, Timothy L. Bailey, Charles P. Elkan and Michael E. Baker.\n\"Meta-MEME: Motif-based Hidden Markov Models of Protein Families\"\nComputer Applications in the Biological Sciences (CABIOS),\n13(4):397-406, 1997.\n"
#define MEME_CITE "If you use this program in your research, please cite:\n\nTimothy L. Bailey and Charles Elkan,\n\"Fitting a mixture model by expectation maximization to\ndiscover motifs in biopolymers\",\nProceedings of the Second International Conference on Intelligent Systems\nfor Molecular Biology, pp. 28-36, AAAI Press, Menlo Park, California, 1994.\n"
#define MEMEChIP_CITE "If you use this program in your research, please cite:\n\nPhilip Machanick and Timothy L. Bailey,\n\"MEME-ChIP: motif analysis of large DNA datasets\",\nBioinformatics 27(12):1696-1697, 2011.\n"
#define MEME_SUITE_CITE "If you use this program in your research, please cite:\n\nTimothy L. Bailey, James Johnson, Charles E. Grant, William S. Noble,\n\"The MEME Suite\",\nNucleic Acids Research, 43(W1):W39-W49, 2015.\n"
#define MoMo_CITE "If you use this program in your research, please cite:\n\nAlice Cheng, Charles Grant, Timothy L. Bailey and William Noble,\n\"MoMo: Discovery of statistically significant post-translational modification motifs\", \nBioinformatics, 35(16):2774-2782, 2018.\n"
#define PSPs_CITE "If you use this program in your research, please cite:\n\nTimothy L. Bailey, Mikael Boden, Tom Whitington and Philip Machanick,\n\"The value of position-specific priors in motif discovery using MEME\",\nBMC Bioinformatics, 11(1):179, 2010.\n"
#define SEA_CITE "If you use this program in your research, please cite:\n\nTimothy L. Bailey and Charles E. Grant, \"SEA: Simple Enrichment Analysis of motifs\",\nBioRxiv, August 24, 2021.\n"
#define SpaMo_CITE "If you use this program in your research, please cite:\n\nTom Whitington, Martin C. Frith, James Johnson and Timothy L. Bailey\n\"Inferring transcription factor complexes from ChIP-seq data\",\nNucleic Acids Res. 39(15):e98, 2011.\n"
#define STREME_CITE "If you use this program in your research, please cite:\n\nTimothy L. Bailey,\n\"STREME: accurate and versatile sequence motif discovery\",\nBioinformatics, Mar. 24, 2021.\n"
#define Tomtom_CITE "If you use this program in your research, please cite:\n\nShobhit Gupta, JA Stamatoyannopolous, Timothy Bailey and William Stafford Noble,\n\"Quantifying similarity between motifs\",\nGenome Biology, 8(2):R24, 2007.\n"
#define TGene_CITE "If you use this program in your research, please cite:\n\nTimothy O'Connor, Charles E. Grant, Mikael Boden, Timothy L. Bailey,\n\"T-Gene: Improved target gene prediction\",\nBioinformatics, 36(12):3902-3904, 2020.\n"
#define XSTREME_CITE "If you use this program in your research, please cite:\n\nCharles E. Grant and Timothy L. Bailey, \"XSTREME: comprehensive motif analysis of biological sequence datasets\",\nBioRxiv, September 3, 2021.\n"

#endif
